class Year{
  int yearDate; 
  ArrayList<Topic> yearsTopics = new ArrayList<Topic>();
  ArrayList<BookParticle> bookParticles = new ArrayList<BookParticle>(); 
  ArrayList<Book> yearsBooks = new ArrayList<Book>();
  
  Year(int yd){
    yearDate = yd;
    //println(yearDate);
  }
  
  void addTopic(Topic topic){
    yearsTopics.add(topic);
    // format sequentially
    for (Book book : topic.topicBooks){
      yearsBooks.add(book);
    }
  }
  
  void generateSlice(){
    float thetaPerBook = yearsBooks.size() / (float)360;
    
    int i = 0;
    for (Book book : yearsBooks){
      float r = (pow(book.error, 1.7)) + innerCircleRadius;
      float theta = thetaPerBook * i;
      //println(map(yearDate, earliestYear, latestYear, 0, distBetweenSlices * rangeYears));
      //println(theta);
      PVector pos = new PVector(r * cos(radians(theta)), r * sin(radians(theta)), map(yearDate, earliestYear, latestYear, -10 * (distBetweenSlices * rangeYears),  distBetweenSlices * rangeYears));
      //println("foo", pos);
      color c = color(topics[book.topicID].topicColor);
      
      bookParticles.add(new BookParticle(book.title, pos, c));
      i++;
    }
  }
}

class BookParticle implements Comparable<ArrayList<BookParticle>> {
  String title;
  PVector position;
  color c;
  BookParticle(String t, PVector p, int cc){
    title = t; 
    position = p;
    c = cc;
  }
  
  public int compareTo(ArrayList<BookParticle> pairingCollection){
    for(int i = 0; i < pairingCollection.size(); i++){
      if(pairingCollection.get(i).title.equals(this.title)){
        return i;
      }
    }
    return -1;
    //return pairingCollection.contains(this) ? 1 : 0;
  }
}
